"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
exports.__esModule = true;
var PropTypes = require("prop-types");
var React = require("react");
var react_1 = require("react");
var react_native_1 = require("react-native");
var propTypes = __assign({}, react_native_1.Image.propTypes, { indicator: PropTypes.bool, indicatorColor: PropTypes.string, indicatorSize: PropTypes.oneOfType([
        PropTypes.oneOf(['small', 'large']),
        PropTypes.number,
    ]), originalHeight: PropTypes.number, originalWidth: PropTypes.number });
var styles = react_native_1.StyleSheet.create({
    container: {
        alignItems: 'center',
        justifyContent: 'center'
    }
});
var FitImage = (function (_super) {
    __extends(FitImage, _super);
    function FitImage(props) {
        var _this = _super.call(this, props) || this;
        _this.onLoad = function () {
            _this.setState({ isLoading: false });
            _this.refreshStateSize();
            if (typeof _this.props.onLoad === 'function') {
                _this.props.onLoad();
            }
        };
        _this.onLoadStart = function () {
            if (_this.isFirstLoad) {
                _this.setState({ isLoading: true });
                _this.isFirstLoad = false;
            }
        };
        _this.getHeight = function (layoutWidth) {
            if (_this.style && _this.style.height) {
                return _this.style.height;
            }
            return _this.getOriginalHeight() * _this.getRatio(layoutWidth);
        };
        _this.getOriginalHeight = function () { return (_this.props.originalHeight || _this.state.originalHeight || 0); };
        _this.getOriginalWidth = function () { return (_this.props.originalWidth || _this.state.originalWidth || 0); };
        _this.getRatio = function (width) {
            var originalWidth = _this.getOriginalWidth();
            if (originalWidth === 0) {
                return 0;
            }
            var layoutWidth = width || _this.state.layoutWidth || 0;
            return layoutWidth / _this.getOriginalWidth();
        };
        _this.getStyle = function () {
            if (_this.style && _this.style.width) {
                return { width: _this.style.width };
            }
            return { flexGrow: 1 };
        };
        _this.resize = function (event) {
            var width = event.nativeEvent.layout.width;
            var height = Number(_this.getHeight(width));
            _this.setState({
                height: height,
                layoutWidth: width
            });
        };
        _this.refreshStateSize = function () {
            var uri;
            if (_this.props.source instanceof Array) {
                uri = _this.props.source[0].uri;
            }
            else {
                uri = _this.props.source.uri;
            }
            if (!uri) {
                return;
            }
            react_native_1.Image.getSize(uri, function (originalWidth, originalHeight) {
                if (!_this.mounted) {
                    return;
                }
                _this.setStateSize(originalWidth, originalHeight);
            }, function () { return null; });
        };
        _this.setStateSize = function (originalWidth, originalHeight) {
            var height = (_this.state.layoutWidth || 0) / originalWidth;
            _this.setState({
                height: height,
                originalHeight: originalHeight,
                originalWidth: originalWidth
            });
        };
        _this.renderActivityIndicator = function () {
            return (React.createElement(react_native_1.ActivityIndicator, { color: _this.props.indicatorColor, size: _this.props.indicatorSize }));
        };
        _this.style = react_native_1.StyleSheet.flatten(props.style);
        if (_this.style) {
            var size = [_this.style.width, _this.style.height];
            if (size.filter(Boolean).length === 1) {
                throw new Error('Props error: size props must be present ' +
                    'none or both of width and height.');
            }
        }
        var originalSize = [props.originalWidth, props.originalHeight];
        if (originalSize.filter(Boolean).length === 1) {
            throw new Error('Props error: originalSize props must be present ' +
                'none or both of originalWidth and originalHeight.');
        }
        _this.isFirstLoad = true;
        _this.state = {
            height: 0,
            isLoading: false,
            layoutWidth: undefined,
            originalHeight: undefined,
            originalWidth: undefined
        };
        return _this;
    }
    FitImage.prototype.componentDidMount = function () {
        if (this.props.originalWidth && this.props.originalHeight) {
            return;
        }
        this.mounted = true;
        this.refreshStateSize();
    };
    FitImage.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    FitImage.prototype.render = function () {
        var children = this.props.children;
        var ImageComponent = react_native_1.Image;
        if (this.state.isLoading && this.props.indicator !== false) {
            children = this.renderActivityIndicator();
        }
        if (children && react_native_1.ImageBackground) {
            ImageComponent = react_native_1.ImageBackground;
        }
        return (React.createElement(ImageComponent, __assign({}, this.props, { onLayout: this.resize, onLoad: this.onLoad, onLoadStart: this.onLoadStart, source: this.props.source, style: [
                this.style,
                this.getStyle(),
                { height: this.state.height },
                styles.container,
            ] }), children));
    };
    FitImage.propTypes = propTypes;
    return FitImage;
}(react_1.Component));
exports["default"] = FitImage;
